
/* ipshow.c -- Find our IP address */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdint.h>

#include <sys/ioctl.h>
#include <time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <resolv.h>
#include <arpa/inet.h>
#include <linux/if.h>
#include <linux/sockios.h>

#include <netdb.h>


int ipshow(char *astring, size_t asmax)
{
	int sock;
	int iocs; 
	int aax;
	struct ifreq ifr;
	struct sockaddr_in addr; 

	sock = socket(AF_INET, SOCK_DGRAM, 0);

	strcpy(ifr.ifr_name, "eth0");	
	iocs = ioctl(sock, SIOCGIFADDR, &ifr);
	if(iocs < 0) return(iocs);
	
	memcpy( &(addr),  &(ifr.ifr_addr), sizeof(ifr.ifr_addr));

	aax = snprintf(astring, asmax, "%s", inet_ntoa(addr.sin_addr) ); 
	close(sock);
	return(aax);
}


