


/* Panel -- 8 lines of text (max).
	Models:
		menupanel:
			2-8 menu selections
		infopanel:
			panel with info (text or graphics) and
				one defined selection such as "back" or "exit"
*/

#ifndef PANELHINCLUDED
#define PANELHINCLUDED 1

struct panel
{
	int itemcount;		/* 1 for info-panel, 2-8 for a menu-panel. */
	char *itemstrings[8];
	int iselnow;			/* Indicates the present selection */
};


/* Define a panel */
struct panel *makepanel(int icount, char **items);

/* Varargs definition */
struct panel *makepanelV(int icount, ...);

/* Deallocate the panel */
void removepanel(struct panel **PP);

/* Display the panel */
int showpanel(struct panel *P, struct dispinfo *DI); 

/* Move selection in the panel up or down. */
int panelselmove(struct panel *P, int direction); 

/* Return the selection made */
int panelselread(struct panel *P); 


#endif


