
/* m2.c -- uses the mgraf code to do a diagram. */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdint.h>

#include "mgraf.h"
#include "ipshow.h"


int main()
{
	struct dispinfo DI;
	char infobuf[128];
	int ds;

	int xw, dx, xrcat, j; 
	int yw, dy, yrcat;

	char txt[20];

	ds = displayinit(&DI, infobuf, 128);
	if(ds < 0)
	{
		fprintf(stderr, "%s\n", infobuf);
		return(0);
	}

// #define LCD_X 84
// #define LCD_Y 48

	/* Axis lines. Plot area from 6 to LCD_X and LCD_Y-7 to 0 */
	Hline(&DI, 6, LCD_X, LCD_Y-7, 0);
	Vline(&DI, 6, LCD_Y-7, 0, 0); 

	/* Axes from 0 to xw and yw */
	xw = 9;
	yw = 6;

	dx = (LCD_X-6)/xw;
	xrcat = 6;
	for(j = 0; j <= xw; j++)
	{
		snprintf(txt, 20, "%u", j); 
		BlitString(&DI, xrcat-2, LCD_Y - 5, txt);
		Vline(&DI, xrcat, LCD_Y-6, LCD_Y-7, 0);  /* Ticks */
		xrcat += dx;
	}

	dy = (LCD_Y-7) / yw;
	yrcat = LCD_Y-7;
	for(j = 0; j<= yw; j++)
	{
		snprintf(txt, 20, "%u", j); 
		BlitString(&DI, 0, yrcat - 2, txt);
		Hline(&DI, 5, 6, yrcat, 0);
		yrcat -= dy;
	}

	/* Plot some curve of values */
	
	Pixel(&DI, 20, 20, 0);


	// Hline(&DI, 10, 40, 20, 0);
	// Vline(&DI, 10, 20, 30, 0);
	// Vline(&DI, 40, 20, 30, 0);
	// Hline(&DI, 10, 40, 30, 0);

	// for(j = 0; j<20; j++)
	// {
		// Vline(&DI, 3+j, 4, 4+j, 0);
	// }

	// BlitChar(&DI, 50, 10, 'H');
	// BlitChar(&DI, 56, 10, 'E');
	// BlitChar(&DI, 62, 10, 'L');
	// BlitChar(&DI, 68, 10, 'L');
	// BlitChar(&DI, 74, 10, 'O');

	// xrcat = 0;
	// yrcat = 0;
// 
	// for(j = 33; j<127; j++)
	// {
		// BlitChar(&DI, xrcat, yrcat, j);
		// xrcat += 6;
		// if(xrcat >= 83)
		// {
			// xrcat = 0;
			// yrcat += 6;
		// }
	// // }

#if(0)

	BlitLine(&DI, 45, 55, 10, (uint8_t *) "\x55\x55");  
	BlitLine(&DI, 45, 55, 11, (uint8_t *) "\xaa\xaa");
	BlitLine(&DI, 45, 55, 12, (uint8_t *) "\x55\x55");
	BlitLine(&DI, 45, 55, 13, (uint8_t *) "\xaa\xaa");
	BlitLine(&DI, 45, 55, 14, (uint8_t *) "\x55\x55");
	BlitLine(&DI, 45, 55, 15, (uint8_t *) "\xaa\xaa");
	BlitLine(&DI, 45, 55, 16, (uint8_t *) "\x55\x55");
	BlitLine(&DI, 45, 55, 17, (uint8_t *) "\xaa\xaa");

	/* Something look like an A, 5 by 5 or so. */
	BlitLine(&DI, 60, 64, 10, (uint8_t *) "\x70");		// .111....
	BlitLine(&DI, 60, 64, 11, (uint8_t *) "\x88");		// 1...1...
	BlitLine(&DI, 60, 64, 12, (uint8_t *) "\xf8");		// 11111...
	BlitLine(&DI, 60, 64, 13, (uint8_t *) "\x88");		// 1...1...
	BlitLine(&DI, 60, 64, 14, (uint8_t *) "\x88");		// 1...1...

	/* Then a B */
	BlitLine(&DI, 66, 70, 10, (uint8_t *) "\xf0");		// 1111....
	BlitLine(&DI, 66, 70, 11, (uint8_t *) "\x88");		// 1...1...
	BlitLine(&DI, 66, 70, 12, (uint8_t *) "\xf0");		// 1111....
	BlitLine(&DI, 66, 70, 13, (uint8_t *) "\x88");		// 1...1...
	BlitLine(&DI, 66, 70, 14, (uint8_t *) "\xf0");		// 1111....
	
	BlitLine(&DI, 72, 76, 10, (uint8_t *) "\x78");		// .1111...
	BlitLine(&DI, 72, 76, 11, (uint8_t *) "\x80");		// 1.......
	BlitLine(&DI, 72, 76, 12, (uint8_t *) "\x80");		// 1.......
	BlitLine(&DI, 72, 76, 13, (uint8_t *) "\x80");		// 1......
	BlitLine(&DI, 72, 76, 14, (uint8_t *) "\x78");		// .1111...
#endif

	refreshflagged(&DI);

	// refreshfull(&DI);

	// fprintf(stderr, "About to clear...\n" );

	// clear(&DI);
	// sleep(1);

	// gotoxy(&DI, 0, 0);
	// GPset(DI.gpio, MD_D_C);     /* Write Data. */

	// xpa[0] = 0x55;
	// xpa[1] = 0xaa;

	// for(j = 0; j<80; j++)
	// {
		// write(DI.fd, xpa, 2);
		// xpa[0] = j;
		// write(DI.fd, xpa, 1);
	// }

	// fprintf(stderr, "About to clear again ...\n" );
	// clear(&DI);

	displayexit(&DI);
	return(0);
}


	// GPset(PDI->gpio, MD_D_C);     /* Write Data. */
	// GPclear(PDI->gpio, MD_D_C);     /* Write Command. */
	// extern uint8_t TXT5x8[][5] ;



