
/* m1.c -- uses the mgraf code. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <stdint.h>

/* For GPIO */
#include <sys/mman.h>
#include "kgpio.h"

/* For SPI */
#include <sys/ioctl.h>
#include <linux/types.h>
#include <linux/spi/spidev.h>

#include "mgraf.h"

int main(int argc, char **argv)
{
	struct dispinfo DI;
	int ds, j;
	char infobuf[128];
	char intxt[256];

	ds = displayinit(&DI, infobuf, 128);
	if(ds < 0)
	{
		fprintf(stderr, "%s\n", infobuf);
		return(0);
	}

	if(argc > 1)
	{
		for(j = 1; j<argc; j++)
		{
			BlitString(&DI, 0, (j-1)*6, argv[j]); 
		}
	}
	else
	{
		fgets(intxt, 256, stdin);
		BlitString(&DI, 0, 0, intxt); 
	}

	refreshflagged(&DI);

	displayexit(&DI);
	return(0);
}



